import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a starter code sample for creating an Animated Character.
 * 
 * It contains all of the required elements and nothing more. NOTHING
 * in this template should be deleted, unless you really know what you're doing.
 * 
 * Simply copy and rename this class to get started. Use the other samples
 * as examples of how to create Player, Enemy and other types of character.
 * 
 * @author Jordan Cohen 
 * @version v2.0.1
 * @since v1.0.0
 */
public class Template extends AnimatedCharacter
{
    private int speed, animationSpeed;
    public Template () {
    
        // You SHOULD set a speed. You can modify this until your animation looks good to you:
        speed = 60; // pixels to move per SECOND (not per act)
        animationSpeed = 20; // number of animations frames per SECOND 
        changeSpeed(speed, animationSpeed);
        
        // You MUST setup and assign a Primary Animation. This will include importing your graphics and creating Animation
        // objects. Otherwise, you will get a nullpointerexception when the AnimatedCharacter tries to initialize the
        // images. See templates for examples of how to import and load Animations.
        
        setPrimaryAnimation ("my animation");
        
        // OR
        
        primaryAnimation = null; // REPLACE null WITH AN ACTUAL ANIMATION! See samples for examples.
        
        // You MUST assign a starting image:
        // REPLACE THE FOLLOWING LINE to assign a starting image for your Actor.
        // For example:
        // setImage(primaryAnimation.getOneImage(direction, 0));
        // --> would get the 0th element of the current animation
        //     for facing in the same direction. You can use any image
        //     here. It will be the starting image for this Actor. It cannot
        //     be left out, unless you've set an image with the GUI.
        setImage (new GreenfootImage (1,1));
    }
    
    /**
     * Many people don't even know that this exists. This method is automatically called when an object is added to the World,
     * and the parameter w represents that World. It can be very useful. If you don't intend to have an addedToWorld method,
     * just leave this alone. You could delete it, as the superclass' version will be called automatically. However, if you have 
     * your own addedToWorld method, you must call super.addedToWorld as shown here.
     */
    public void addedToWorld (World w){
        super.addedToWorld(w);
        
        // Your code here.
        
    }
    
    /**
     * Act - do whatever the Template wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        
        
        // This will perform the motion and animation, and must be at the end of your act() method:
        super.act();
    }    
    
    /**
     * This method is OPTIONAL and may be deleted if you do not need it.
     * 
     * This method will be called by AnimatedCharacter when a terminal animation has finished running. For example,
     * if you have a terminal animation for swinging a weapon, when the weapon swing is over, this method will be called.
     * This is a good place to take appropriate action (such as setting attacking = false) or start the next animation.
     */
    protected void terminalAnimationComplete () {
        
    }
    
    /**
     * This method is OPTIONAL and may be deleted if you do not need it.
     * 
     * This method is similar to the one above, except that it will be called when an automated movement is complete.
     * So, if you tell an AnimatedCharacter to moveTowards a location, this will be called when it arrives there.
     */
    protected void movementComplete () {
        
    }
}
