import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 *  This world is intended to demonstrate AnimatedCharacter.
 *  
 *  Please see the documentation of the AnimatedCharacter for API and for
 *  detailed instructions on how to get started.
 */

public class MyWorld extends World
{
    private ComplexPlayer cp;
    private SimplePlayer sp;

    private MouseInfo m;

    /**
     * Constructor for objects of class MyWorld.
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        
        sp = new SimplePlayer();
        cp = new ComplexPlayer();
        
        addObject (cp, 300, 200);

        addObject (new Rock(), 100, 100);
        addObject (new Rock(), 500, 300);
        addObject (new Enemy(), 150, 150);
        addObject (new Enemy(), 450, 250);
        addObject (new Charger(), 450, 150);
        addObject (new Charger(), 150, 250);
    }

    public void act ()
    {
        /**if (Greenfoot.isKeyDown("o")){
            p.stopMoving();
            p.setLocation (300, 200);
        }*/
    }
}
